#version 440

out vec4 fsColor;

in vec2 TexCoords;

uniform sampler2D colourTexture;
uniform sampler2D depthTexture;


// Taken from the learnopengl website
// https://learnopengl.com/Advanced-OpenGL/Depth-testing
float near = 0.1;
float far = 100.0;
float LinearizeDepth(float depth)
{
    float z = depth * 2.0 - 1.0; // back to NDC 
    return (2.0 * near * far) / (far + near - z * (far - near));
}


// Returns value between 0 and 1
// Once again, I cant find the original source for this rand function,
// but it seems no one else can either...
// https://stackoverflow.com/questions/12964279/whats-the-origin-of-this-glsl-rand-one-liner
float rand(vec2 co)
{
    return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43758.5453);
}


void main()
{
    fsColor = texture(colourTexture, TexCoords);

    float linearDepth = LinearizeDepth(texture2D(depthTexture, TexCoords).r);

    // This basically just checks if the depth is pretty much the far plane
    // If it is, render the starfield, otherwise leave our planet model
    if (linearDepth > far * 0.99)
    {
        // Sky Background Color
        fsColor = vec4(vec3(0.1, 0.2, 0.4) * TexCoords.y, 1);

        // This rand cant go very low precision, so use rand twice 
        if (rand(TexCoords) < 0.01 && rand(TexCoords * 2) < 0.01) fsColor = vec4(1);
    }
}